
%{
#include <math.h>
#include <string.h>

#include "parse.h"

int line = 1;
static int findkw(char *n);
%}


%%

[a-zA-Z]([a-zA-Z0-9])*	{ return findkw(yytext); }
-?[0-9]+		{ yylval.f = atof(yytext); return NUM; }
-?[0-9]*"."[0-9]+	{ yylval.f = atof(yytext); return NUM; }
-?[0-9]+"."[0-9]*	{ yylval.f = atof(yytext); return NUM; }
\"(\\.|[^\\"])*\"	{ yylval.strp = strdup(yytext); return STRING; }
#.*$			{ }
\n			{ line++; }
[ \t\v\f]		{ }
.			{ printf("returning %d\n", yytext[0]); return yytext[0]; }

%%

static struct kws {
	char *n;
	int num;
} kws[] = {
	"Name", NAME,
	"Descr", DESCR,
	"MU", TMU,
	"VCT", TVCT,
	"CCG", TCCG,
	"CCP", TCCP,
	"CGP", TCGP,
	"RGI", TRGI,
	"Plotx", TPLOTX,
	"Ploty", TPLOTY,
	"Plotg", TPLOTG,
	"Wa", TWA,
	"EPS", TEPS,
	"Diode", DIOD,
	"Triode", TRIOD,
	"Tetrode", PENTOD,
	"Pentode", PENTOD,
	"Hexode", HEPTOD,
	"Heptode", HEPTOD,
	"Octode", OKTOD,
	"Screen", SCREEN,
	"Param", PARAM,
	"Type", TYPE,
};
static int sz = sizeof(kws)/sizeof(kws[0]);

static int
findkw(char *n)
{
	int i;

	for (i = 0; i < sz; i++) {
		if (strcasecmp(n, kws[i].n) == 0)
			return kws[i].num;
	}
	yylval.strp = n;
	return IDENT;
}

int
yywrap(void)
{
	return 1;
}
