
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <err.h>

int
main(int argc, char *argv[])
{
	double E1, MU, EX, KG1, KP, KVB, Vp, Vg, Ip, Ic, y;

	if (argc != 9)
		errx(1, "usage: %s <MU> <EX> <KG1> <KP> <KVB> <Vp> <Vg> <Ip>", argv[0]);

	MU = atof(argv[1]);
	EX = atof(argv[2]);
	KG1 = atof(argv[3]);
	KP = atof(argv[4]);
	KVB = atof(argv[5]);
	Vp = atof(argv[6]);
	Vg = atof(argv[7]);
	Ip = atof(argv[8]);

	E1 = (Vp/KP) * log(1+exp(KP*(1/MU+Vg/sqrt(KVB+Vp*Vp))));
	Ic = (pow(E1, EX)/KG1) * (2*!signbit(E1));

	y = (Ic - Ip);
	y = sqrt(y*y);

	printf("Vp %f and Vg %f gives Ip %f (%f) (y==%f)\n", Vp, Vg, Ic, Ip, y);
	return 0;
}
